package com.fluentadflowreactnativesdk

import com.fluent.adflowsdk.adflow.IAdflowListener
import com.facebook.react.uimanager.ThemedReactContext
import com.facebook.react.modules.core.DeviceEventManagerModule
import android.util.Log

class AdFlowListener(context: ThemedReactContext?, viewId: String) : IAdflowListener {
  private var reactContext: ThemedReactContext?
  private var viewId: String? = ""
  init {
    this.viewId = viewId
    this.reactContext = context
  }
  override fun onViewDismiss(viewId: String) {
    Log.d("tag", "close event viewId :" + viewId)
    if (this.reactContext != null) {
      this.reactContext
        ?.getJSModule(DeviceEventManagerModule.RCTDeviceEventEmitter::class.java)
        ?.emit("onAdFlowContainerClosed", viewId)
    }
  }
  override fun onViewLoaded(viewId: String) {
    Log.d("tag", "load event viewId :" + viewId)
    if (this.reactContext != null) {
      this.reactContext
        ?.getJSModule(DeviceEventManagerModule.RCTDeviceEventEmitter::class.java)
        ?.emit("onAdFlowContainerShow", viewId)
    }
  }
  override fun onContentHeightChanged(viewId: String, height: String ) {
    Log.d("tag", "height changed event viewId :" + viewId)
    if (this.reactContext != null) {
      this.reactContext
        ?.getJSModule(DeviceEventManagerModule.RCTDeviceEventEmitter::class.java)
        ?.emit("onAdFlowContainerHeightChanged" , viewId + "$" + height)
    }
  }
}
