"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.WidgetNativeComponent = exports.FluentAdFlowWidgetView = void 0;
var _reactNative = require("react-native");
var _react = _interopRequireWildcard(require("react"));
var _package = _interopRequireDefault(require("../package.json"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
/**
 * fluent-adflow-widget.js
 *
 * Licensed under the Fluent Software Development Kit (SDK) Terms of Use
 * Version 1.0 (the "License");
 *
 * You may not use this file except in compliance with the License.
 *
 * You may obtain a copy of the License at https://fluentco.com
 */

const eventManagerEmitter = new _reactNative.NativeEventEmitter(_reactNative.NativeModules.AdsViewEventEmitter);
const packageName = _package.default.name;
const packageVersion = _package.default.version;
class FluentAdFlowWidgetView extends _react.Component {
  subscriberOnAdFlowContainerClosed = eventManagerEmitter.addListener('onAdFlowContainerClosed', viewId => {
    if (viewId == this.state.viewId) {
      this.props.onAdShow && this.props.onAdShow(false);
      console.log('>>>>>> onAdFlowContainerClosed -> viewId: ', viewId);
      this.setState({
        height: 0
      });
    }
  });
  subscriberOnAdFlowContainerShow = eventManagerEmitter.addListener('onAdFlowContainerShow', viewId => {
    if (viewId == this.state.viewId) {
      console.log('>>>>>> onAdFlowContainerShow -> viewId: ', viewId);
      this.props.onAdShow && this.props.onAdShow(true);
      this.setState({
        height: this.props.style.height
      });
    }
  });
  subscriberOnAdFlowContainerHeightChanged = eventManagerEmitter.addListener('onAdFlowContainerHeightChanged', result => {
    const resArry = result.split('$');
    if (resArry.length > 1) {
      const viewId = resArry[0];
      const height = resArry[1];
      if (viewId == this.state.viewId) {
        console.log('>>>>>> onAdFlowContainerHeightChanged -> viewId: ', viewId);
        console.log('                                      -> height : ', parseInt(height));
        this.setState({
          height: parseInt(height)
        });
      }
    }
  });
  subscriberOnError = eventManagerEmitter.addListener('onError', viewId => {
    if (viewId == this.state.viewId) {
      console.log('>>>>>> onError -> viewId: ', viewId);
      this.setState({
        height: 0
      });
    }
  });
  subscriberOnValidationFailed = eventManagerEmitter.addListener('onValidationFailed', viewId => {
    if (viewId == this.state.viewId) {
      console.log('>>>>>> onValidationFailed -> viewId: ', viewId);
    }
  });
  subscriberOnNotified = eventManagerEmitter.addListener('onNotified', viewId => {
    if (viewId == this.state.viewId) {
      console.log('>>>>>> onNotified -> viewId: ', viewId);
    }
  });
  constructor(props) {
    super(props);
    this.state = {
      height: 0,
      viewId: Date.now() + '' + Math.floor(Math.random() * 1000)
    };
  }
  render() {
    var params = {
      ...this.props.params
    };
    params.viewId = this.state.viewId;
    return /*#__PURE__*/_react.default.createElement(WidgetNativeComponent, {
      style: [this.props.style, {
        height: this.state.height
      }],
      params: params,
      wrapperName: packageName,
      wrapperVersion: packageVersion
    });
  }
  componentWillUnmount() {
    this.subscriberOnAdFlowContainerClosed.remove();
    this.subscriberOnAdFlowContainerShow.remove();
    this.subscriberOnAdFlowContainerHeightChanged.remove();
    this.subscriberOnError.remove();
    this.subscriberOnValidationFailed.remove();
    this.subscriberOnNotified.remove();
  }
}
exports.FluentAdFlowWidgetView = FluentAdFlowWidgetView;
const WidgetNativeComponent = (0, _reactNative.requireNativeComponent)('FluentAdFlowWidgetView');
exports.WidgetNativeComponent = WidgetNativeComponent;
var _default = FluentAdFlowWidgetView;
exports.default = _default;
//# sourceMappingURL=fluent-adflow-widget.js.map